for plr in players_iterate() do
  if plr:is_human() then
    chat.msg("\n===%s of the %s===", plr.name, plr.nation:plural_translation())
    local ucount, s, cities, cnos = {}, 0, {}, {}
    for city in plr:cities_iterate() do
      table.insert(cities, {name = city.name, founded = city.original.name, size= city.size,
        x= city.tile.x, y = city.tile.y,
        ter = city.tile.terrain:name_translation(), upres = city.tile:num_units(),
        sqr = city:map_sq_radius(),
        culture = --[[city:culture()]]0,
        civil = --[[city:is_celebrating() and 'celebrating' or city:is_happy() and 'happy'
        or city:is_unhappy() and 'disorder' or]] '???',
        govc = --[[city:is_gov_center() and 'gov.center' or]] '', cap = --[[city:is_capital()]]
        city:has_building(find.building_type("Palace"))--[[2.5: non-universal but works]] and 'capital'
         or '', usupp = 0, id = city.id
      })
      cnos[city] = #cities
    end
    local unhomed = 0
    for unit in plr:units_iterate() do
      ucount[unit.utype] = (ucount[unit.utype] or 0) + 1
      
      local ct = find.city(nil, unit.homecity)
      if ct then
        ct = cities[cnos[ct]]
        ct.usupp = ct.usupp + 1
      else
        unhomed = unhomed+1
      end
    end
    chat.msg("There are %d unhomed unit(s)", unhomed)
    for ut, uc in pairs(ucount) do
      s = s + uc
      chat.msg(" Has %d x %s", uc, ut:name_translation())
    end
    chat.msg("Total must be %d = %d units", plr:num_units(), s)
    table.sort(cities, function(a,b)
       if a.cap~='' then return true elseif b.cap~='' then return false
       else return a.size > b.size end
    end)
    for n, t in ipairs(cities) do
      chat.msg("%d.\t%s (%d)\n Founded by %s at (%d,%d) on %s. Works radius %f.\n" ..
               " Culture is %d, civil state: %s. %s %s. Units: %d present, %d supported.",
               n, t.name, t.size, t.founded, t.x, t.y, t.ter, math.sqrt(t.sqr),
               t.culture, t.civil, t.govc, t.cap, t.upres, t.usupp)
      --[[ --This code works wrong and can kill your client!
      for plr2 in players_iterate() do
        local insp = find.city(nil, t.id):inspire_partisans(plr2)
        if insp > 0 then
          chat.msg("Would inspire partisans as %d if captured by %s",
               find.city(nil, t.id):inspire_partisans(plr2), plr2.name)
        end
      end]]
    end
  end
end

chat.msg("Saved: %s", _freeciv_state_dump())

