function enum_players()
for p in players_iterate() do
  log.normal("%s#%d%s", p.name, p.id, p.is_alive and "" or " (dead)")
end
end

function count_units(pid)
local p = find.player(pid)
local uc, pnl = {}, 4
for u in p:units_iterate() do
  uc[u.utype] = (uc[u.utype] or 0) + 1
end

for t, n in pairs(uc) do
  log.normal("%d x %s", n, t:rule_name())
end
end

function count_all_units_vet()
local pt, ut = {},{}

for p in players_iterate() do
local uc,tuc={},0
for u in p:units_iterate() do
  tuc=tuc+1
  local uv = uc[u.utype]
  if not uv then
    uv = {[u.veteran] = 1}
    uc[u.utype] = uv
  else 
    uv[u.veteran] = (uv[u.veteran] or 0) + 1
  end
end
if tuc>0 then
  --filling ut
  for t, vc in pairs(uc) do
    local uvc = ut[t]
    if not uvc then
      uvc = {}
      for r, c in pairs(vc) do uvc[r]=c end
      ut[t] = uvc
    else
      for r, c in pairs(vc) do 
        uvc[r] = (uvc[r] or 0)+c
      end
    end
  end
  pt[p.name] = uc -- pt={[plrname]={[utype]={[vet]=cnt}}}
  if pnl<p.name:len() then pnl=p.name:len() end
end
end --players_iterate
-- ut = {[utype]={[vet]=count}}
-- Prepare head matrix
local fill0 = {("%%%ds"):format(pnl)}
local uta, utn, utcw = {}, {}, {}
for t, vc in pairs(ut) do
  local utv = {}
  nx = t:rule_name()
  table.insert(uta,{nx, t})
  utcw[t] = nx:len() --minimal type colgroup width
  for v, n in pairs(vc) do
    table.insert(utv, v)
  end
  table.sort utv--known ranks of t sorted;#"%3d "=4
  if utcw<4*(#utv+1) then utcw=4*#utv end
  ut[t] = utv
end
table.sort uta, function(a,b) a[1]<b[1] end --known utypes sorted

for p in players_iterate() do
for t, n in pairs(uc) do
  log.normal("  %s:", t:rule_name())
  for v, c in pairs(n) do
    log.normal("    vet(%d) x %d", v, c)
  end -- pairs(uc[ut])
end -- pairs(uc)
end--players_iterate()
end

local wonders, i = {}, 1
local bt = find.building_type(1)

while bt do if bt:is_wonder() then wonders[bt] = bt:rule_name() end end

function my_wonders(plr)
local wc = {}
for k,v in pairs(wonders) do wc[v] = "--nowhere--" end
for c in find.player(plr):cities_iterate() do
  for bt, n in pairs(wonders) do
    if c:has_building(bt) then
      wc[n] = c.name
    end
  end
end
for w, c in pairs(wc) do
  log.normal("%s in %s", w, c)
end
end

function tech_to_trade()
  for p in players_iterate() do
    local i,t = 1,find.tech_type(1)
    while t do
      if p:knows_tech(t) and not client_player():knows_tech(t)
      then log.normal("%s knows %s", p.name, t:rule_name())
      elseif client_player():knows_tech(t) and not p:knows_tech(t)
      then log.normal("%s doesn't know %s", p.name, t:rule_name())
      end
      i=i+1
      t=find.tech_type(i)
    end
  end
end
